unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ComboBox1: TComboBox;
    FontDlg: TFontDialog;
    pnl4memos: TPanel;
    ScrollBox1: TScrollBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox1CloseUp(Sender: TObject);
  private



    procedure AdapteFontSizeMemo(FontSize: Integer; Sender: TObject);
    procedure AdapteHauteurMemo(Sender: TObject);

    function GetVirtualTextWidth(S: String; afont:TFont): Integer;
    function GetVirtualTextHeight(afont:TFont): Integer;

  protected
    MemosContainer : Array[0..2] of TMemo;
  public
    procedure CreateMemos;
    procedure FillMemos;
  end;


Const
  cText : String = 'Ne dirait-on pas, à chaque voyage, il fut pris d''un grand pouvoir.'+
                   'Tenez-vous-en à votre plan dans son entier, remettre et retenir le '+
                   'saint service  selon la forme et de volume, produisant pour ainsi dire'+
                   'violemment en arrière en poussant un gros soupir.';

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ComboBox1CloseUp(Sender: TObject);
var
  i, cnt : integer;
  Obj : TObject;
begin
  cnt := ScrollBox1.ControlCount;
  if cnt>0 then
  begin
    dec(cnt);
    For i:=0 to cnt do
    begin
      Obj := ScrollBox1.Controls[I];
      if (Obj is TMemo) then
      begin
        AdapteFontSizeMemo(StrToInt(ComboBox1.Text), Obj);
        AdapteHauteurMemo(obj);
      end;
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  CreateMemos;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FillMemos;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if fontdlg.Execute then
  begin
    MemosContainer[TButton(Sender).Tag].Font := fontdlg.Font;
    AdapteHauteurMemo(MemosContainer[TButton(Sender).Tag]);
  end;
end;

procedure TForm1.AdapteFontSizeMemo(FontSize: Integer; Sender: TObject);
begin
  TMemo(Sender).Font.Size:= FontSize;
end;

procedure TForm1.AdapteHauteurMemo(Sender: TObject);
var
  nbligne, i : integer;
begin
  nbLigne := round((GetVirtualTextWidth(TMemo(Sender).Text, TMemo(Sender).Font) / TMemo(Sender).ClientWidth)+0.5);
  // 8 = marge haut/bas, 2 = hauteur entre les lignes
  I := 8+(2*nbligne) + (nbLigne * GetVirtualTextHeight(TMemo(Sender).Font));
  //ShowMessage('Lines : ' + Inttostr(nbligne)+' - Height = '+inttostr(i));
  TMemo(Sender).Height:= I;
end;

function TForm1.GetVirtualTextWidth(S: String; afont : TFont): Integer;
var
  c: TBitmap;
begin
  c := TBitmap.Create;
  try
    c.Canvas.Font.Assign(aFont);
    result := (c.Canvas.TextWidth(S));
  finally
    c.Free;
  end;
end;

function TForm1.GetVirtualTextHeight(afont: TFont): Integer;
var
  c: TBitmap;
begin
  c := TBitmap.Create;
  try
    c.Canvas.Font.Assign(aFont);
     result := (c.Canvas.TextHeight('pT'));
  finally
    c.Free;
  end;
end;

procedure TForm1.CreateMemos;
var
  i:integer;
begin
  For i:=0 to 2 do
  begin
    MemosContainer[i] := TMemo.Create(Self);
    With MemosContainer[i] do
    begin
      Parent := ScrollBox1;
      Align := alTop;
      Height := 100;
      Lines.Clear;
      WordWrap := True;
    end;
  end;
end;

procedure TForm1.FillMemos;
var
  i:integer;
begin
  For i:=0 to 2 do
  begin
    With MemosContainer[i] do
    begin
      Lines.Text := cText;
    end;
  end;
end;

end.

